<template>
  <div class="flex-grow-1 flex-row" v-bind:class="displayClass">
    <template v-if="loading">
      <div class="d-flex flex-grow-1">
        <div class="mx-auto my-4">
          <h2 class="text-center mt-4">A carregar...</h2>
          <span class="align-middle">
            <clip-loader :loading="loading" color="#007bff" size="50px" radius="100%"></clip-loader>
          </span>
          <div class="mb-4"></div>
        </div>
      </div>
    </template>
    <template v-else-if="error">
      <div class="d-flex flex-grow-1">
        <div class="text-center mx-auto my-4">
          <h1><font-awesome-icon icon="dizzy"></font-awesome-icon></h1>
          <div class="error-message">{{ error }}</div>
        </div>
      </div>
    </template>
    <template v-else>
      <div style="height: 400px; width: 100%; overflow: auto">
        <template v-if="isShown">
          <div class="chart-container-area" style="display:block; position: relative; height: 350px; width: 70%; float: left">
            <base-chart ref="chart" :chart-data="dataCollection" :options="chartOptions"></base-chart>
          </div>
        </template>
        <div class="chart-selector" style="width: 30%; float: right">
          <h3>Datasets</h3>
          <select v-model="dataSelect" multiple>
            <option value="temperature">Temperatura</option>
            <option value="pressure">Pressão</option>
            <option value="humidity">Humidade</option>
          </select>
        </div>
      </div>
    </template>
  </div>
</template>

<script>
import moment from 'moment'
import { dataProvider, axisProvider, labelProvider, colorProvider } from './data.js'

import ClipLoader from 'vue-spinner/src/ClipLoader'
import BaseChart from '@/core/charts/mixins/BaseChart'
// Utilities
import { findParentComponentByName } from '@/core/util'

// Mixins
import ParentWorkspaceMixin from '@/dashboard/mixins/ParentWorkspace'
import MomentMixin from '@/core/mixins/moment'


export default {
  name: 'infochart',

  mixins: [
    ParentWorkspaceMixin,
    MomentMixin,
  ],

  props: {
    name: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      loading: true,
      error: null,
      dataSelect: ['temperature'],
      isShown: false,
    }
  },

  computed: {
    queryPanel: {
      get() {
        return findParentComponentByName(this.$parent, 'querypanel')
      }
    },

    displayClass: {
      get() {
        return this.queryPanel.currentPanel === this.name ? 'd-flex' : 'd-none'
      },
    },

    dataCollection: {
      get() {
        return {
          datasets: this.dataSelect.map((item) => {
            return {
              label: labelProvider(item),
              yAxisID: axisProvider(item).id,
              backgroundColor: colorProvider(item).background,
              borderColor: colorProvider(item).border,
              data: dataProvider(item).map((entry) => {
                return { y: entry.value, t: entry.datetime }
              })
            }
          })
        }
      },
    },

    chartOptions: {
      get() {
        return {
          responsive: true,
          maintainAspectRatio: false,
          tooltips: {
            mode: 'index',
            intersect: false,
            callbacks: {
              title: (item) => {
                return moment(item[0].label).format('YYYY-MM-DD HH:mm')
              },
            },
          },
          hover: {
            mode: 'nearest',
            intersect: true
          },
          scales: {
            xAxes: [{
              type: 'time',
              time: {
                unit: 'hour',
                displayFormats: { hour: 'H[h]' }
              },
              scaleLabel: {
                display: true,
                labelString: 'Data e hora'
              },
            }],
            yAxes: this.dataSelect.map((item, index) => {
              return Object.assign({
                position: index % 2 === 0 ? 'left' : 'right',
              }, axisProvider(item))
            }),
          }
        }
      },
    },
  },

  watch: {
    displayClass(after) {
      this.isShown = after === 'd-flex'
    }
  },

  components: {
    BaseChart,
    ClipLoader,
  },

  mounted() {
    this.loading = false
  },
}
</script>

<style>
.chart-container-area {
}
</style>
